% !TEX root = ../Documentation_Bern_RTOS_PAI.tex

\chapter{Conclusions}
\label{chap:conclusions}

\section{Evaluation of the Objectives}

The overall objective of the Bern RTOS is to implement a fail-safe system from scratch. The introduction into Rust showed that the programming languages ownership model will already solve many concurrency issues at compile time. Further, can code be generic yet strong typed by using traits and generics with bounds. These characteristics eradicate the bugs typically found in C code that arise from void pointer casting.

The development of a demo application fulfilled its purpose and illustrated the capabilities and limits of Rust on embedded devices. For example, with embedded-hal the advantage is that all platforms share a single HAL interface, but the interface is incomplete and feature support is limited on some microcontrollers. The insights gained from the demo application will find their way into the RTOS design.

From the RTOS survey we can conclude that systems are shifting towards IoT applications, offering optional network stacks and connectivity drivers. Similar to the fail-safety goals of the Bern RTOS, other RTOS with network connectivity also focus on safety and security. The architecture draft for the Bern RTOS was heavily influenced by the structure of Zephyr, which uses many generic interfaces. The book \ucos-III provides a detailed view on a kernel implementation, from which we have already seen some aspects. The book will certainly affect the scheduler and IPC development in the next project.

At the beginning of the project the plan was to implement a simple scheduler as well. But, there was not enough time because the Rust code introduction took a little longer than expected. For this reason, the scheduler prototype is postponed to the next project.

All in all, we have seen that Rust is a good choice to write a fail-safe RTOS and the insights from existing RTOS helped to formulate a concept.

\section{Outlook}

There are many uncertainties in the Bern RTOS architecture. The next step will be to start the development of a simple scheduler, i.e. no time-slicing, no MPU, just a static table of tasks. Once the minimal prototype works, more functionality will be gradually added, always validating and adapting the Bern RTOS concept.

The biggest uncertainty is whether and how the MPU can be used to restrict tasks access to stack and heap only. And if so, we need to decide where to draw the line between kernel and thread mode. A small kernel leads to a more stable system, but has more overhead from the many syscalls. In the next project these issues have to tackled as early on as possible by proof of concept implementations.

In the best case the kernel with memory protection and basic IPC is implemented at the end of the next project. But emphasis is on proving and adapting the concept of memory protection and resource permission introduced in this project.


\section{Personal Retrospective}

When I first started looking for different RTOS, I was overwhelmed by their shier number. Structuring and grouping them helped me to get a picture of the features most of them offer. The concept of the Bern RTOS now already includes these features even though it will take ages before I can even consider to, for example, support a file system. The concept has to be taken with a grain of salt in general, it is the best case scenario with many uncertainties. I will refine the architecture as soon as I have more experience with Rust on embedded devices.

The tooling of Zephyr is beyond everything I have ever seen for a microcontroller. In embedded projects I always try to isolate hardware dependencies and board configurations, Zephyr solved this elegantly with the Devicetree. The \ucos-III book is the best documentation of an RTOS kernel I have seen so far, and I will consult the book once more during the implementation. The Zephyr documentation is good place to cross-reference, as the project uses modern strategies.

I have also enjoyed writing my first embedded Rust application. It took some time until compiler stopped rejecting my code. But at least the error messages were helpful. I believe that Rusts concepts do fit the needs and concerns of embedded systems well. The limiting factor currently is the hardware support, which is maintained by the community instead of the microcontroller vendor.

If I were to redo this project, I would probably squeeze in the scheduler implementation I originally planned for. Mainly to test my understanding of Rusts ownership more. I would also start to write the documentation earlier.

Currently, I am looking forward to a challenging second project, where I will get a chance to dig deep into the ARM architecture, work on my concept again and struggle with Rust a little more.